Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jdesktop.swingx.renderer
Class WrappingIconPanel

    java.lang.Object
      java.awt.Component
          java.awt.Container
              javax.swing.JComponent
                  javax.swing.JPanel
                      org.jdesktop.swingx.JXPanel
                          org.jdesktop.swingx.renderer.WrappingIconPanel

All Implemented Interfaces:
  java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, javax.accessibility.Accessible, javax.swing.Scrollable, PainterAware

    public class WrappingIconPanel

extends JXPanel
implements PainterAware

Compound component for usage in tree renderer.

Supports setting an icon for the node and a delegate component which is used to show the text/content of the node. The delegate component can be shared across renderers.

This implements the PainterAware by delegating to the delegate component if that is of type PainterAware. Does nothing if not.

See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class javax.swing.JPanel
`javax.swing.JPanel.AccessibleJPanel`

Nested classes/interfaces inherited from class javax.swing.JComponent
`javax.swing.JComponent.AccessibleJComponent`

Nested classes/interfaces inherited from class java.awt.Container
`java.awt.Container.AccessibleAWTContainer`

Nested classes/interfaces inherited from class java.awt.Component
`java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

Field Summary
`protected javax.swing.JComponent` | `delegate`

Fields inherited from class javax.swing.JComponent
`accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`WrappingIconPanel()` Instantiates and configures a WrappingIconPanel with the dropHack enabled.
`WrappingIconPanel(boolean dropHackEnabled)` Instantiates and configures a WrappingIconPanel with the dropHack property set as indicated by the boolean.

Method Summary
`javax.swing.JComponent` | `getComponent()` Returns the delegate component.
`java.awt.Rectangle` | `getDelegateBounds()` Returns the bounds of the delegate component or null if the delegate is null.
`javax.swing.Icon` | `getIcon()` Returns the icon used in this panel, may be null.
`Painter<?>` | `getPainter()`
`boolean` | `isVisible()`
`void` | `setBackground(java.awt.Color bg)` Sets the background color for this component by
`void` | `setComponent(javax.swing.JComponent comp)` Sets the delegate component.
`void` | `setComponentOrientation(java.awt.ComponentOrientation o)`
`void` | `setDropHackEnabled(boolean dropHackEnabled)` Sets the dropHackEnabled property.
`void` | `setFont(java.awt.Font font)`
`void` | `setForeground(java.awt.Color bg)`
`void` | `setIcon(javax.swing.Icon icon)` Sets the icon.
`void` | `setPainter(Painter<?> painter)` Sets the delegate's Painter if it is of type PainterAware.

Methods inherited from class org.jdesktop.swingx.JXPanel
`getAlpha, getBackgroundPainter, getEffectiveAlpha, getPainterChangeListener, getPreferredScrollableViewportSize, getScrollableBlockIncrement, getScrollableHeightHint, getScrollableTracksViewportHeight, getScrollableTracksViewportWidth, getScrollableUnitIncrement, getScrollableWidthHint, isInheritAlpha, isPaintBorderInsets, paint, paintComponent, setAlpha, setBackgroundPainter, setInheritAlpha, setPaintBorderInsets, setScrollableHeightHint, setScrollableTracksViewportHeight, setScrollableTracksViewportWidth, setScrollableWidthHint`

Methods inherited from class javax.swing.JPanel
`getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

Methods inherited from class javax.swing.JComponent
`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paintBorder, paintChildren, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

Methods inherited from class java.awt.Container
`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusBackward, transferFocusDownCycle, validate, validateTree`

Methods inherited from class java.awt.Component
`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusUpCycle`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### delegate

    protected javax.swing.JComponent delegate

Constructor Detail

### WrappingIconPanel

    public WrappingIconPanel()

  Instantiates and configures a WrappingIconPanel with the dropHack enabled.

### WrappingIconPanel

    public WrappingIconPanel(boolean dropHackEnabled)

  Instantiates and configures a WrappingIconPanel with the dropHack property set as indicated by the boolean.

  Parameters:
    `dropHackEnabled` - a boolean indicating whether the drop hack should be enabled.
  See Also:
    `isVisible()`

Method Detail

### setComponentOrientation

    public void setComponentOrientation(java.awt.ComponentOrientation o)

  Overridden to update the icon position.

  Overrides:
    `setComponentOrientation` in class `java.awt.Component`

### setIcon

    public void setIcon(javax.swing.Icon icon)

  Sets the icon.

  Parameters:
    `icon` - the icon to use.

### getIcon

    public javax.swing.Icon getIcon()

  Returns the icon used in this panel, may be null.

  Returns:
    the icon used in this panel, may be null.

### setComponent

    public void setComponent(javax.swing.JComponent comp)

  Sets the delegate component.

  Parameters:
    `comp` - the component to add as delegate.

### getComponent

    public javax.swing.JComponent getComponent()

  Returns the delegate component.

  Returns:
    the delegate component.

### setBackground

    public void setBackground(java.awt.Color bg)

  Sets the background color for this component by

  Overridden to set the background of the delegate and icon label as well.

  Overrides:
    `setBackground` in class `JXPanel`
  Parameters:
    `bg` - the desired background `Color`
  See Also:
    `java.swing.JComponent#getBackground`, `JComponent.setOpaque(boolean)`

### setForeground

    public void setForeground(java.awt.Color bg)

  Overridden to set the foreground of the delegate and icon label as well.

  Overrides:
    `setForeground` in class `javax.swing.JComponent`

### setFont

    public void setFont(java.awt.Font font)

  Overridden to set the Font of the delegate as well.

  Overrides:
    `setFont` in class `javax.swing.JComponent`

### isVisible

    public boolean isVisible()

  Overridden to hack around #766-swingx: cursor flickering in DnD when dragging over tree column. This is a core bug (#6700748) related to painting the rendering component on a CellRendererPane. A trick around is to let this return false.

  Some LayoutManagers don't layout an invisible component, so need to make the hack-enabled configurable. This implementation will return false if isDropHackEnabled, super.isVisible otherwise.

  Overrides:
    `isVisible` in class `java.awt.Component`

### getPainter

    public Painter<?> getPainter()

  Returns the delegate's Painter if it is of type PainterAware or null otherwise.

  Specified by:
    `getPainter` in interface `PainterAware`
  Returns:
    the delegate's Painter or null.

### setPainter

    public void setPainter(Painter<?> painter)

  Sets the delegate's Painter if it is of type PainterAware. Does nothing otherwise.

  Specified by:
    `setPainter` in interface `PainterAware`
  Parameters:
    `painter` - the Painter to apply to the delegate.

### getDelegateBounds

    public java.awt.Rectangle getDelegateBounds()

  Returns the bounds of the delegate component or null if the delegate is null. PENDING JW: where do we use it? Maybe it was for testing only?

  Returns:
    the bounds of the delegate, or null if the delegate is null.

### setDropHackEnabled

    public void setDropHackEnabled(boolean dropHackEnabled)

  Sets the dropHackEnabled property.

  The default value is true.

  Parameters:
    `dropHackEnabled` -
  See Also:
    `isVisible()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010. All Rights Reserved.